
int nSquares = 2;

Square[] squares = new Square[nSquares];

void setup() {
  size(500,500);
  
  //Create Objects
  for(int i=0; i<nSquares; i++) {
    squares[i] = new Square(); 
  }
}


void draw() {
  //Draw Objects
  for(int i=0; i<nSquares; i++) {
    squares[i].draw();
  }
}


class Square {
  float x,y;
  float w,h;
  
  color offColor = color(255,255,255);
  color onColor  = color(255,0,0);
  
  Square() {
    x = random(width);
    y = random(height);
    
    w = 50;
    h = w;
    
  }
  
  
  //Draw the Square
  void draw() {
    if(checkForPress()) {
      fill(onColor);
    } else {
      fill(offColor);
    }
    
    rect(x,y,w,h);
    ellipse(x+w/2, y + h/2, w,h);
  }
  
  
  //Check for Mouse Press, return true or false
  boolean checkForPress() {
    if(mousePressed) {
      //Circular Detection
      /*
      if(dist(mouseX,mouseY,x + w/2, y + h/2) < w/2) {
        fill(onColor);
      }*/
      
      //Square Detection
      if(mouseX > x && mouseX < (x + w) {    //Check for x inside square
        if(mouseY > y && mouseY < (y + h)) { // Check for y inside square
         return true; //Mouse inside and pressed
        }
      }  
    }
    
    return false; //Mouse outside or not pressed
  }
}
