class Square {
  float x,y;
  float w,h;
  
  Circle c;
  
  color offColor = color(255,255,255);
  color onColor  = color(255,0,0);
  
  Square() {
    x = random(width);
    y = random(height);
    
    w = 50;
    h = w;
    
    c = new Circle(x + w/2, y + w/2, w/2);
    
  }
  
  
  //Draw the Square
  void draw() {
    c.x = x + w/2;
    c.y = y + w/2;
    
    if(checkForPress()) {
      fill(onColor);
      x = mouseX - w/2;
      y = mouseY - h/2;
    } else {
      fill(offColor);
    }
    
    rect(x,y,w,h);
    c.draw();
  }
  
  //Check for Mouse Press, return true or false
  boolean checkForPress() {
    if(mousePressed) {
      //Circular Detection
      /*
      if(dist(mouseX,mouseY,x + w/2, y + h/2) < w/2) {
        fill(onColor);
      }*/
      
      //Square Detection
      if(mouseX > x && mouseX < (x + w)) {    //Check for x inside square
        if(mouseY > y && mouseY < (y + h)) { // Check for y inside square
         return true; //Mouse inside and pressed
        }
      }  
    }
    
    return false; //Mouse outside or not pressed
  }
}
